<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_65) on Fri Aug 22 15:06:29 CEST 2014 -->
<title>SSLSocketChannel2</title>
<meta name="date" content="2014-08-22">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="SSLSocketChannel2";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/SSLSocketChannel2.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../org/java_websocket/SocketChannelIOHelper.html" title="class in org.java_websocket"><span class="strong">Prev Class</span></a></li>
<li><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?org/java_websocket/SSLSocketChannel2.html" target="_top">Frames</a></li>
<li><a href="SSLSocketChannel2.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.java_websocket</div>
<h2 title="Class SSLSocketChannel2" class="title">Class SSLSocketChannel2</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>org.java_websocket.SSLSocketChannel2</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>java.io.Closeable, java.lang.AutoCloseable, java.nio.channels.ByteChannel, java.nio.channels.Channel, java.nio.channels.ReadableByteChannel, java.nio.channels.WritableByteChannel, <a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="strong">SSLSocketChannel2</span>
extends java.lang.Object
implements java.nio.channels.ByteChannel, <a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></pre>
<div class="block">Implements the relevant portions of the SocketChannel interface with the SSLEngine wrapper.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#bufferallocations">bufferallocations</a></strong></code>
<div class="block">Should be used to count the buffer allocations.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected static java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#emptybuffer">emptybuffer</a></strong></code>
<div class="block">This object is used to feed the <code>SSLEngine</code>'s wrap and unwrap methods during the handshake phase.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.concurrent.ExecutorService</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#exec">exec</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#inCrypt">inCrypt</a></strong></code>
<div class="block">encrypted data incoming</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#inData">inData</a></strong></code>
<div class="block">raw payload incomming</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#outCrypt">outCrypt</a></strong></code>
<div class="block">encrypted data outgoing</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected javax.net.ssl.SSLEngineResult</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#readEngineResult">readEngineResult</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected java.nio.channels.SelectionKey</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#selectionKey">selectionKey</a></strong></code>
<div class="block">used to set interestOP SelectionKey.OP_WRITE for the underlying channel</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.nio.channels.SocketChannel</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#socketChannel">socketChannel</a></strong></code>
<div class="block">the underlying channel</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected javax.net.ssl.SSLEngine</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#sslEngine">sslEngine</a></strong></code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected java.util.List&lt;java.util.concurrent.Future&lt;?&gt;&gt;</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#tasks">tasks</a></strong></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected javax.net.ssl.SSLEngineResult</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#writeEngineResult">writeEngineResult</a></strong></code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#SSLSocketChannel2(java.nio.channels.SocketChannel,%20javax.net.ssl.SSLEngine,%20java.util.concurrent.ExecutorService,%20java.nio.channels.SelectionKey)">SSLSocketChannel2</a></strong>(java.nio.channels.SocketChannel&nbsp;channel,
                 javax.net.ssl.SSLEngine&nbsp;sslEngine,
                 java.util.concurrent.ExecutorService&nbsp;exec,
                 java.nio.channels.SelectionKey&nbsp;key)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#close()">close</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>java.nio.channels.SelectableChannel</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#configureBlocking(boolean)">configureBlocking</a></strong>(boolean&nbsp;b)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#connect(java.net.SocketAddress)">connect</a></strong>(java.net.SocketAddress&nbsp;remote)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#consumeDelegatedTasks()">consumeDelegatedTasks</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#consumeFutureUninterruptible(java.util.concurrent.Future)">consumeFutureUninterruptible</a></strong>(java.util.concurrent.Future&lt;?&gt;&nbsp;f)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#createBuffers(javax.net.ssl.SSLSession)">createBuffers</a></strong>(javax.net.ssl.SSLSession&nbsp;session)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#finishConnect()">finishConnect</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isBlocking()">isBlocking</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isConnected()">isConnected</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isHandShakeComplete()">isHandShakeComplete</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isInboundDone()">isInboundDone</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isNeedRead()">isNeedRead</a></strong>()</code>
<div class="block">returns whether readMore should be called to fetch data which has been decoded but not yet been returned.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isNeedWrite()">isNeedWrite</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#isOpen()">isOpen</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#processHandshake()">processHandshake</a></strong>()</code>
<div class="block">This method will do whatever necessary to process the sslengine handshake.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#read(java.nio.ByteBuffer)">read</a></strong>(java.nio.ByteBuffer&nbsp;dst)</code>
<div class="block">Blocks when in blocking mode until at least one byte has been decoded.<br>
 When not in blocking mode 0 may be returned.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#readMore(java.nio.ByteBuffer)">readMore</a></strong>(java.nio.ByteBuffer&nbsp;dst)</code>
<div class="block">This function does not read data from the underlying channel at all.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#readRemaining(java.nio.ByteBuffer)">readRemaining</a></strong>(java.nio.ByteBuffer&nbsp;dst)</code>
<div class="block"><a href="../../org/java_websocket/SSLSocketChannel2.html#read(java.nio.ByteBuffer)"><code>read(ByteBuffer)</code></a> may not be to leave all buffers(inData, inCrypt)</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>java.net.Socket</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#socket()">socket</a></strong>()</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#transfereTo(java.nio.ByteBuffer,%20java.nio.ByteBuffer)">transfereTo</a></strong>(java.nio.ByteBuffer&nbsp;from,
           java.nio.ByteBuffer&nbsp;to)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>private java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#unwrap()">unwrap</a></strong>()</code>
<div class="block">performs the unwrap operation by unwrapping from <a href="../../org/java_websocket/SSLSocketChannel2.html#inCrypt"><code>inCrypt</code></a> to <a href="../../org/java_websocket/SSLSocketChannel2.html#inData"><code>inData</code></a></div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>private java.nio.ByteBuffer</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#wrap(java.nio.ByteBuffer)">wrap</a></strong>(java.nio.ByteBuffer&nbsp;b)</code>&nbsp;</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#write(java.nio.ByteBuffer)">write</a></strong>(java.nio.ByteBuffer&nbsp;src)</code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../org/java_websocket/SSLSocketChannel2.html#writeMore()">writeMore</a></strong>()</code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="emptybuffer">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>emptybuffer</h4>
<pre>protected static&nbsp;java.nio.ByteBuffer emptybuffer</pre>
<div class="block">This object is used to feed the <code>SSLEngine</code>'s wrap and unwrap methods during the handshake phase.</div>
</li>
</ul>
<a name="exec">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>exec</h4>
<pre>protected&nbsp;java.util.concurrent.ExecutorService exec</pre>
</li>
</ul>
<a name="tasks">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>tasks</h4>
<pre>protected&nbsp;java.util.List&lt;java.util.concurrent.Future&lt;?&gt;&gt; tasks</pre>
</li>
</ul>
<a name="inData">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>inData</h4>
<pre>protected&nbsp;java.nio.ByteBuffer inData</pre>
<div class="block">raw payload incomming</div>
</li>
</ul>
<a name="outCrypt">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>outCrypt</h4>
<pre>protected&nbsp;java.nio.ByteBuffer outCrypt</pre>
<div class="block">encrypted data outgoing</div>
</li>
</ul>
<a name="inCrypt">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>inCrypt</h4>
<pre>protected&nbsp;java.nio.ByteBuffer inCrypt</pre>
<div class="block">encrypted data incoming</div>
</li>
</ul>
<a name="socketChannel">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>socketChannel</h4>
<pre>protected&nbsp;java.nio.channels.SocketChannel socketChannel</pre>
<div class="block">the underlying channel</div>
</li>
</ul>
<a name="selectionKey">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>selectionKey</h4>
<pre>protected&nbsp;java.nio.channels.SelectionKey selectionKey</pre>
<div class="block">used to set interestOP SelectionKey.OP_WRITE for the underlying channel</div>
</li>
</ul>
<a name="sslEngine">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sslEngine</h4>
<pre>protected&nbsp;javax.net.ssl.SSLEngine sslEngine</pre>
</li>
</ul>
<a name="readEngineResult">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>readEngineResult</h4>
<pre>protected&nbsp;javax.net.ssl.SSLEngineResult readEngineResult</pre>
</li>
</ul>
<a name="writeEngineResult">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeEngineResult</h4>
<pre>protected&nbsp;javax.net.ssl.SSLEngineResult writeEngineResult</pre>
</li>
</ul>
<a name="bufferallocations">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>bufferallocations</h4>
<pre>protected&nbsp;int bufferallocations</pre>
<div class="block">Should be used to count the buffer allocations.
 But because of #190 where HandshakeStatus.FINISHED is not properly returned by nio wrap/unwrap this variable is used to check whether <a href="../../org/java_websocket/SSLSocketChannel2.html#createBuffers(javax.net.ssl.SSLSession)"><code>createBuffers(SSLSession)</code></a> needs to be called.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="SSLSocketChannel2(java.nio.channels.SocketChannel, javax.net.ssl.SSLEngine, java.util.concurrent.ExecutorService, java.nio.channels.SelectionKey)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>SSLSocketChannel2</h4>
<pre>public&nbsp;SSLSocketChannel2(java.nio.channels.SocketChannel&nbsp;channel,
                 javax.net.ssl.SSLEngine&nbsp;sslEngine,
                 java.util.concurrent.ExecutorService&nbsp;exec,
                 java.nio.channels.SelectionKey&nbsp;key)
                  throws java.io.IOException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="consumeFutureUninterruptible(java.util.concurrent.Future)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>consumeFutureUninterruptible</h4>
<pre>private&nbsp;void&nbsp;consumeFutureUninterruptible(java.util.concurrent.Future&lt;?&gt;&nbsp;f)</pre>
</li>
</ul>
<a name="processHandshake()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>processHandshake</h4>
<pre>private&nbsp;void&nbsp;processHandshake()
                       throws java.io.IOException</pre>
<div class="block">This method will do whatever necessary to process the sslengine handshake.
 Thats why it's called both from the <a href="../../org/java_websocket/SSLSocketChannel2.html#read(java.nio.ByteBuffer)"><code>read(ByteBuffer)</code></a> and <a href="../../org/java_websocket/SSLSocketChannel2.html#write(java.nio.ByteBuffer)"><code>write(ByteBuffer)</code></a></div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="wrap(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>wrap</h4>
<pre>private&nbsp;java.nio.ByteBuffer&nbsp;wrap(java.nio.ByteBuffer&nbsp;b)
                          throws javax.net.ssl.SSLException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>javax.net.ssl.SSLException</code></dd></dl>
</li>
</ul>
<a name="unwrap()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>unwrap</h4>
<pre>private&nbsp;java.nio.ByteBuffer&nbsp;unwrap()
                            throws javax.net.ssl.SSLException</pre>
<div class="block">performs the unwrap operation by unwrapping from <a href="../../org/java_websocket/SSLSocketChannel2.html#inCrypt"><code>inCrypt</code></a> to <a href="../../org/java_websocket/SSLSocketChannel2.html#inData"><code>inData</code></a></div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>javax.net.ssl.SSLException</code></dd></dl>
</li>
</ul>
<a name="consumeDelegatedTasks()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>consumeDelegatedTasks</h4>
<pre>protected&nbsp;void&nbsp;consumeDelegatedTasks()</pre>
</li>
</ul>
<a name="createBuffers(javax.net.ssl.SSLSession)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createBuffers</h4>
<pre>protected&nbsp;void&nbsp;createBuffers(javax.net.ssl.SSLSession&nbsp;session)</pre>
</li>
</ul>
<a name="write(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>write</h4>
<pre>public&nbsp;int&nbsp;write(java.nio.ByteBuffer&nbsp;src)
          throws java.io.IOException</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>write</code>&nbsp;in interface&nbsp;<code>java.nio.channels.WritableByteChannel</code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="read(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>read</h4>
<pre>public&nbsp;int&nbsp;read(java.nio.ByteBuffer&nbsp;dst)
         throws java.io.IOException</pre>
<div class="block">Blocks when in blocking mode until at least one byte has been decoded.<br>
 When not in blocking mode 0 may be returned.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>read</code>&nbsp;in interface&nbsp;<code>java.nio.channels.ReadableByteChannel</code></dd>
<dt><span class="strong">Returns:</span></dt><dd>the number of bytes read.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="readRemaining(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>readRemaining</h4>
<pre>private&nbsp;int&nbsp;readRemaining(java.nio.ByteBuffer&nbsp;dst)
                   throws javax.net.ssl.SSLException</pre>
<div class="block"><a href="../../org/java_websocket/SSLSocketChannel2.html#read(java.nio.ByteBuffer)"><code>read(ByteBuffer)</code></a> may not be to leave all buffers(inData, inCrypt)</div>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>javax.net.ssl.SSLException</code></dd></dl>
</li>
</ul>
<a name="isConnected()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isConnected</h4>
<pre>public&nbsp;boolean&nbsp;isConnected()</pre>
</li>
</ul>
<a name="close()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close()
           throws java.io.IOException</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.io.Closeable</code></dd>
<dt><strong>Specified by:</strong></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.lang.AutoCloseable</code></dd>
<dt><strong>Specified by:</strong></dt>
<dd><code>close</code>&nbsp;in interface&nbsp;<code>java.nio.channels.Channel</code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="isHandShakeComplete()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isHandShakeComplete</h4>
<pre>private&nbsp;boolean&nbsp;isHandShakeComplete()</pre>
</li>
</ul>
<a name="configureBlocking(boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>configureBlocking</h4>
<pre>public&nbsp;java.nio.channels.SelectableChannel&nbsp;configureBlocking(boolean&nbsp;b)
                                                      throws java.io.IOException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="connect(java.net.SocketAddress)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>connect</h4>
<pre>public&nbsp;boolean&nbsp;connect(java.net.SocketAddress&nbsp;remote)
                throws java.io.IOException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="finishConnect()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>finishConnect</h4>
<pre>public&nbsp;boolean&nbsp;finishConnect()
                      throws java.io.IOException</pre>
<dl><dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="socket()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>socket</h4>
<pre>public&nbsp;java.net.Socket&nbsp;socket()</pre>
</li>
</ul>
<a name="isInboundDone()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isInboundDone</h4>
<pre>public&nbsp;boolean&nbsp;isInboundDone()</pre>
</li>
</ul>
<a name="isOpen()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isOpen</h4>
<pre>public&nbsp;boolean&nbsp;isOpen()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code>isOpen</code>&nbsp;in interface&nbsp;<code>java.nio.channels.Channel</code></dd>
</dl>
</li>
</ul>
<a name="isNeedWrite()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isNeedWrite</h4>
<pre>public&nbsp;boolean&nbsp;isNeedWrite()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WrappedByteChannel.html#isNeedWrite()">isNeedWrite</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></code></dd>
</dl>
</li>
</ul>
<a name="writeMore()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>writeMore</h4>
<pre>public&nbsp;void&nbsp;writeMore()
               throws java.io.IOException</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WrappedByteChannel.html#writeMore()">writeMore</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>java.io.IOException</code></dd></dl>
</li>
</ul>
<a name="isNeedRead()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isNeedRead</h4>
<pre>public&nbsp;boolean&nbsp;isNeedRead()</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html#isNeedRead()">WrappedByteChannel</a></code></strong></div>
<div class="block">returns whether readMore should be called to fetch data which has been decoded but not yet been returned.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WrappedByteChannel.html#isNeedRead()">isNeedRead</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></code></dd>
<dt><span class="strong">See Also:</span></dt><dd><code>ReadableByteChannel.read(ByteBuffer)</code>, 
<a href="../../org/java_websocket/WrappedByteChannel.html#readMore(java.nio.ByteBuffer)"><code>WrappedByteChannel.readMore(ByteBuffer)</code></a></dd></dl>
</li>
</ul>
<a name="readMore(java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>readMore</h4>
<pre>public&nbsp;int&nbsp;readMore(java.nio.ByteBuffer&nbsp;dst)
             throws javax.net.ssl.SSLException</pre>
<div class="block"><strong>Description copied from interface:&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html#readMore(java.nio.ByteBuffer)">WrappedByteChannel</a></code></strong></div>
<div class="block">This function does not read data from the underlying channel at all. It is just a way to fetch data which has already be received or decoded but was but was not yet returned to the user.
 This could be the case when the decoded data did not fit into the buffer the user passed to <code>ReadableByteChannel.read(ByteBuffer)</code>.</div>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WrappedByteChannel.html#readMore(java.nio.ByteBuffer)">readMore</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></code></dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code>javax.net.ssl.SSLException</code></dd></dl>
</li>
</ul>
<a name="transfereTo(java.nio.ByteBuffer, java.nio.ByteBuffer)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>transfereTo</h4>
<pre>private&nbsp;int&nbsp;transfereTo(java.nio.ByteBuffer&nbsp;from,
              java.nio.ByteBuffer&nbsp;to)</pre>
</li>
</ul>
<a name="isBlocking()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>isBlocking</h4>
<pre>public&nbsp;boolean&nbsp;isBlocking()</pre>
<dl>
<dt><strong>Specified by:</strong></dt>
<dd><code><a href="../../org/java_websocket/WrappedByteChannel.html#isBlocking()">isBlocking</a></code>&nbsp;in interface&nbsp;<code><a href="../../org/java_websocket/WrappedByteChannel.html" title="interface in org.java_websocket">WrappedByteChannel</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/SSLSocketChannel2.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../org/java_websocket/SocketChannelIOHelper.html" title="class in org.java_websocket"><span class="strong">Prev Class</span></a></li>
<li><a href="../../org/java_websocket/WebSocket.html" title="interface in org.java_websocket"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../index.html?org/java_websocket/SSLSocketChannel2.html" target="_top">Frames</a></li>
<li><a href="SSLSocketChannel2.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
